//////////////////////////////////////////////////////////////////////////////
//
//	Skeleton.h
// 
//  WDM  API
//
//////////////////////////////////////////////////////////////////////////////
#ifndef _SKELETON_
#define _SKELETON_

#ifndef DRIVER

#include <winioctl.h>

#endif // DRIVER

// IOCTL info, needs to be visible for application

#define SKELETONDRV_IOCTL_INDEX  0x00080

#define SUM_TWO_INTEGER			CTL_CODE(FILE_DEVICE_UNKNOWN,			\
									 SKELETONDRV_IOCTL_INDEX + 0,	\
									 METHOD_BUFFERED,				\
									 FILE_ANY_ACCESS)

#ifdef DRIVER

#define DRIVER_NAME				"CALCDRV"
#define DRIVER_VERSION				"1.00"
#define NAME_MAX				100

typedef struct _DEVICE_EXTENSION
{
	CHAR			 DeviceName[NAME_MAX];	// string name of device
	CHAR			 LinkName[NAME_MAX];	// string name of symbolic link
	PDEVICE_OBJECT	 PhysDeviceObject;		// physical device object
	PDEVICE_OBJECT	 StackDeviceObject;		// stack device object
	BOOLEAN			 Stopped;				// current state of device status
	ULONG			 IRPCount;				// number of IRPs completed with this device object
	LARGE_INTEGER	 ByteCount;				// number of bytes of data passed with this device object
	ULONG			 Instance;				// instance of device
	PVOID			 DeviceSpecificExt;		// pointer to extension things specific to device
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;

NTSTATUS
DriverEntry(IN PDRIVER_OBJECT DriverObject, IN PUNICODE_STRING RegistryPath);

NTSTATUS
Skeleton_Dispatch(IN PDRIVER_OBJECT DriverObject, IN PIRP Irp);

NTSTATUS
Dispatch_Create(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);

NTSTATUS
Dispatch_Close(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);

NTSTATUS
Dispatch_Read(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);

#endif
#endif
//////////////////////////////////////////////////////////////////////////////
//
//       Header End
//
//////////////////////////////////////////////////////////////////////////////